﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Rapida;

namespace Test
{    
    public partial class FTest : Form
    {
        Rapida.Rapida rapida = new Rapida.Rapida();

        public FTest()
        {
            InitializeComponent();            
        }

        private void btnCertificate_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Подключение сертификата");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.X509FromFileOrStore = false;
            rapida.Certificate = tbCertificate.Text;
            rapida.GetCertificate();
            tbFunction.Text = "";
            tbRequest.Text = "";
            tbResponse.Text = "";
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnPaymExtIdGen_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Генерация идентификатора запроса");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.PaymExtIdGen();
            tbPaymExtId.Text = rapida.PaymExtId;
            tbFunction.Text = "";
            tbRequest.Text = "";
            tbResponse.Text = "";
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnCheck_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос Check()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.PaymExtId = tbPaymExtId.Text;
            rapida.PaymSubjTp = (int)nudPaymSubjTp.Value;
            rapida.Amount = (int)nudAmount.Value;
            rapida.Params = tbParams.Text;
            rapida.TermType = tbTermType.Text;
            rapida.TermId = tbTermId.Text;
            rapida.FeeSum = (int)nudFeeSum.Value;
            rapida.Check();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnPayment_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос Payment()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.PaymExtId = tbPaymExtId.Text;
            rapida.PaymSubjTp = (int)nudPaymSubjTp.Value;
            rapida.Amount = (int)nudAmount.Value;
            rapida.Params = tbParams.Text;
            rapida.TermType = tbTermType.Text;
            rapida.TermId = tbTermId.Text;
            rapida.FeeSum = (int)nudFeeSum.Value;
            rapida.Payment();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос Cancel()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.PaymExtId = tbPaymExtId.Text;
            rapida.Cancel();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnGetPaymSubj_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос GetPaymSubj()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.Params = tbParams.Text;
            rapida.Code = (int)nudCode.Value;
            rapida.GetPaymSubj();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnGetBalance_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос GetBalance()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.PaymExtId = tbPaymExtId.Text;
            rapida.GetBalance();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnGetFee_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос GetFee()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.GetFee();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }

        private void btnGetStatus_Click(object sender, EventArgs e)
        {
            lbxLog.Items.Add("Выполняется запрос GetStatus()");
            lbxLog.SelectedIndex = lbxLog.Items.Count - 1;
            rapida.Host = tbHost.Text;
            rapida.PaymExtId = tbPaymExtId.Text;
            rapida.GetStatus();
            tbFunction.Text = rapida.Function;
            tbRequest.Text = rapida.Request;
            tbResponse.Text = rapida.Response;
            tbLastErrorCode.Text = rapida.LastErrorCode.ToString();
            tbLastErrorDescription.Text = rapida.LastErrorDescription;
        }
    }
}
